%%%============================================================================
%%% Time-stamp: <2007-09-06 09:58:06 j>
%%%
%%% File    :
%%% Purpose :
%%% Author  :
%%% License :
%%% Created : 2007-09-03 14:55:20 j
%%%
%%%============================================================================

%% Tree ADT
-record(tree, {op,
               kids = [],
               val  = 0,
               state}).

kids(T)                   -> T#tree.kids.
kids_set(T, Kids)         -> T#tree{kids=Kids}.
state_label(T)            -> T#tree.state.
state_label_set(T, State) -> T#tree{state=State}.

op_label(T) ->
    case T#tree.op of
        cnsti -> if T#tree.val == 0 -> ioi;
                    true -> T#tree.op
                 end;
        Op -> Op
    end.

%% Utilities
-define(TESTCALL(Call), io:format("Call ~s:~n~w~n~n", [??Call, Call])).

indent(Str) ->
    S = "\s\s" ++ lists:flatmap(fun ($\n) -> "\n\s\s"; (C) -> [C] end, Str),
    string:strip(S, right).

%%% Local Variables:
%%% mode: erlang
%%% End:
