%%%============================================================================
%%% Time-stamp: <2007-09-04 18:03:10 j>
%%%
%%% File    : smoke.erl
%%% Purpose : Run eburg test suite.
%%% Author  : j@crunchy.svirfneblin.org
%%% License : BSD
%%% Created : 2007-09-04 14:37:29 j
%%%
%%%============================================================================

-module(smoke).
-author('j@crunchy.svirfneblin.org').

-include_lib("eunit/include/eunit.hrl").

smoke_test_() ->
    [?_assert(doit("canonical")),
     ?_assert(doit("misc")),
     ?_assert(doit("mlburg")),
     ?_assert(doit("ocamlburg"))
    ].

doit(File) ->
    eburg:file(File),
    c:c(File),
    os:cmd("erl -noshell -s "++File++" main -s erlang halt > "++File++".tmp"),
    Eq = os:cmd("diff "++File++".out "++File++".tmp") == [],
    os:cmd("rm "++File++".tmp"),
    Eq.

%%% Local Variables:
%%% mode: erlang
%%% End:
